pipeline {
    agent any
    parameters {
  
        string(name: "VM_USERNAME", defaultValue: "ubuntu", description: 'Usuario da maquina AWS')
        string(name: "CHAVE_PEM", defaultValue: "-o StrictHostKeyChecking=no", description: 'Chave pem')
        string(name: "IP_AWS", defaultValue: "18.191.68.249", description: 'Ip da maquina AWS')
        string(name: "REGISTRY", defaultValue: "registry-itau.mastertech.com.br")
        string(name: "DOCKER_IMAGE", defaultValue: "jonathan-api-investimentos")
        string(name: "NOME", defaultValue: "investimentos")
    }
    stages {
        stage('Test') {
            steps {
                echo 'Testando..'
                script{
                     def port = sh (
                        script: "awk -v min=64000 -v max=65000 'BEGIN{srand(); print int(min+rand()*(max-min+1))}'",
                        returnStdout: true
                    ).trim()    
                    /*
                    Utilizamos esse bloco withEnv para definir variáveis de ambiente que serão visíveis no escopo
                    desse stage 'Test'
                    */
    
                    withEnv([
                        "MYSQL_USER=root",
                        "MYSQL_HOST=localhost",
                        "MYSQL_PORT=$port",
                        "MYSQL_PASS=123"]) { 
                             /*
                                Essas variáveis contendo as credenciais do banco precisar estar disponíveis quando o container for
                                iniciado e não somente durante a etapa de build da imagem, por isso estamos passando essas variáveis
                                como argumento para o comando build que será substituída dentro do Dockerfile.
                                PS a explicação disso continua no arquivo Dockerfile.
                                */
                    docker.image("mysql:latest").withRun("-e MYSQL_ROOT_PASSWORD=${env.MYSQL_PASS} -e MYSQL_DATABASE=banco -p ${env.MYSQL_PORT}:3306"){c ->
                        sh "while ! mysqladmin ping -h0.0.0.0 -P ${env.MYSQL_PORT} --silent; do sleep 1; done"
                        sh "./mvnw test"
                    }
                }
                }    
            }
        }
        stage('Build') {
            steps {
                echo 'Empacotando..'
                sh './mvnw package -DskipTests'  
            }
        }
        stage('Docker-Push') {
            steps {
                echo 'Push docker..'
                script {
                    withEnv([
                        "MYSQL_USER=usuario",
                        "MYSQL_HOST=database-1.c8tdp5ff2x6f.us-east-2.rds.amazonaws.com",
                        "MYSQL_PORT=3306",
                        "MYSQL_PASS=123"]) { 
                    docker.withRegistry("https://${params.REGISTRY}", "registry_credential"){
                        def customImage = docker.build("${params.REGISTRY}/${params.DOCKER_IMAGE}:${env.BUILD_ID}" , "--build-arg MYSQL_HOST=${MYSQL_HOST} --build-arg MYSQL_PORT=${MYSQL_PORT} --build-arg MYSQL_USER=${MYSQL_USER} --build-arg MYSQL_PASS=${MYSQL_PASS} .")
                        customImage.push("${env.BUILD_ID}")
                        customImage.push('latest')
                        echo "${customImage}"
                    }
                }    
                }
            }
        }
        stage('Deploy') {
            when {branch 'master'}
            steps {
                echo 'Pull docker..'
                script {
                    sh "ssh ${params.CHAVE_PEM} -t ${params.VM_USERNAME}@${params.IP_AWS} docker pull ${params.REGISTRY}/${params.DOCKER_IMAGE}:latest"
                    sh "ssh ${params.CHAVE_PEM} -t ${params.VM_USERNAME}@${params.IP_AWS} docker stop ${params.NOME}"
                    sh "ssh ${params.CHAVE_PEM} -t ${params.VM_USERNAME}@${params.IP_AWS} docker rm ${params.NOME}"
                    sh "ssh ${params.CHAVE_PEM} -t ${params.VM_USERNAME}@${params.IP_AWS} docker run --name ${params.NOME} -d -p 5000:8080 ${params.REGISTRY}/${params.DOCKER_IMAGE}:latest"
                }
            }
        }    
    }
    post {
            always {
                echo 'Clean..'
                cleanWs()
            }
            success {
                echo 'FUNCIONOUUU!!!'    
            }
            failure {
                echo 'DEU RUIM :('
            }
    }         
}